## arm-compute-library 23.08+dfsg

=== CMakeLists.txt ===
# Copyright (c) 2023 Arm Limited.
#
# SPDX-License-Identifier: MIT
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to
# deal in the Software without restriction, including without limitation the
# rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
# sell copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

cmake_minimum_required(VERSION 3.13 FATAL_ERROR)

# ---------------------------------------------------------------------
# Project ArmCompute

list(APPEND CMAKE_MESSAGE_CONTEXT ArmCompute)
project(
  ArmCompute
  VERSION 32.0.0
  DESCRIPTION
    "The Arm Compute Library is a collection of low-level machine learning functions optimized for Arm® Cortex®-A CPU and Arm® Mali™ GPU architectures"
  LANGUAGES C CXX ASM)

include(GNUInstallDirs)

set(CMAKE_C_STANDARD 99)
set(CMAKE_C_STANDARD_REQUIRED ON)
set(CMAKE_C_EXTENSIONS OFF)

set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/Options.cmake)
include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/Version.cmake)

# Require at least gcc/g++ 11) CMAKE_CXX_COMPILER_VERSION OR
if(CMAKE_C_COMPILER_VERSION VERSION_LESS 10.2 OR CMAKE_CXX_COMPILER_VERSION
                                                 VERSION_LESS 10.2)
  message(
    FATAL_ERROR "gcc and g++ version => 10.2 is required for building project!")
endif()

# ---------------------------------------------------------------------
# Configuration

set(CMAKE_CXX_FLAGS_DEBUG "-O0 -g -gdwarf-2 -DARM_COMPUTE_ASSERTS_ENABLED")
# Default to Release Build
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  set(CMAKE_BUILD_TYPE
      "Release"
      CACHE
        STRING
        "Choose build type, available options are: Debug, Release, RelWithDebInfo"
        FORCE)
endif()

# ---------------------------------------------------------------------
# Information

message(STATUS "Arm Compute Library ${PROJECT_VERSION}")

message(VERBOSE "-----------------------------------------------------")
message(VERBOSE "Build information:")
list(APPEND CMAKE_MESSAGE_INDENT "  ")
message(VERBOSE "Host system: ${CMAKE_SYSTEM_NAME}")
message(VERBOSE "Host processor: ${CMAKE_SYSTEM_PROCESSOR}")
message(VERBOSE "Build path: ${CMAKE_CURRENT_BINARY_DIR}")
message(VERBOSE "Enable OpenCL acceleration: ${ENABLE_OPENCL}")
message(VERBOSE "Enable CPU acceleration: ${ENABLE_NEON}")
list(POP_BACK CMAKE_MESSAGE_INDENT)
message(VERBOSE "-----------------------------------------------------")

# ---------------------------------------------------------------------
# Compile options and features

set(COMMON_CXX_FLAGS
    -Wall
    -DARCH_ARM
    -Wextra
    -Wdisabled-optimization
    -Wformat=2
    -Winit-self
    -Wstrict-overflow=2
    -Wswitch-default
    -Woverloaded-virtual
    -Wformat-security
    -Wctor-dtor-privacy
    -Wsign-promo
    -Weffc++
    -Wno-overlength-strings
    -Wno-ignored-attributes
    -Wlogical-op
    -Wnoexcept
    -Wstrict-null-sentinel
    -Wno-misleading-indentation
    -O3)

# Disable note popups on compiler ABI changes
if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
  add_compile_options("-Wno-psabi")
endif()

# Compile with -Werror if ARM_COMPUTE_WERROR set
if(ARM_COMPUTE_WERROR)
  add_compile_options("-Werror")
endif()

# Compile with -fno-exceptions flag and define ARM_COMPUTE_EXCEPTIONS_DISABLED
# if ARM_COMPUTE_EXCEPTIONS not set
if(NOT ARM_COMPUTE_EXCEPTIONS)
  add_compile_options("-fno-exceptions")
  add_definitions(-DARM_COMPUTE_EXCEPTIONS_DISABLED)
endif()

# Link OpenMP libraries if ARM_COMPUTE_OPENMP set
if(ARM_COMPUTE_OPENMP)
  find_package(OpenMP)
  if(OpenMP_CXX_FOUND)
    link_libraries(OpenMP::OpenMP_CXX)
    add_definitions(-DARM_COMPUTE_OPENMP_SCHEDULER)
  else()
    message(FATAL_ERROR "OPENMP was set but no OpenMP library was found!")
  endif()
endif()

# ---------------------------------------------------------------------
# SVE Library

add_library(arm_compute_sve "")
target_compile_options(arm_compute_sve
                       PRIVATE "-march=armv8.2-a+sve+fp16+dotprod")
target_compile_definitions(arm_compute_sve PRIVATE ARM_COMPUTE_ENABLE_BF16)
target_compile_definitions(arm_compute_sve PRIVATE ENABLE_SVE)
target_compile_definitions(arm_compute_sve PRIVATE ARM_COMPUTE_ENABLE_SVE)
target_include_directories(
  arm_compute_sve
  PUBLIC $<INSTALL_INTERFACE:include>
         $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
         ${CMAKE_CURRENT_SOURCE_DIR}
  PUBLIC src
         src/core/NEON/kernels/arm_conv
         src/core/NEON/kernels/arm_gemm
         src/core/NEON/kernels/assembly
         src/core/cpu/kernels/assembly
         src/cpu/kernels/assembly
         src/core/NEON/kernels/arm_gemm/merges)

# ---------------------------------------------------------------------
# SVE2 Library

add_library(arm_compute_sve2 "")
target_compile_options(arm_compute_sve2
                       PRIVATE "-march=armv8.6-a+sve2+fp16+dotprod")
target_compile_definitions(arm_compute_sve2 PRIVATE ARM_COMPUTE_ENABLE_SVE2)
target_compile_definitions(arm_compute_sve2 PRIVATE ARM_COMPUTE_ENABLE_BF16)
target_compile_definitions(arm_compute_sve2 PRIVATE ENABLE_SVE)
target_compile_definitions(arm_compute_sve2 PRIVATE ARM_COMPUTE_ENABLE_SVE)
target_include_directories(
  arm_compute_sve2
  PUBLIC $<INSTALL_INTERFACE:include>
         $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
         ${CMAKE_CURRENT_SOURCE_DIR}
  PUBLIC src
         src/core/NEON/kernels/arm_conv
         src/core/NEON/kernels/arm_gemm
         src/core/NEON/kernels/assembly
         src/core/cpu/kernels/assembly
         src/cpu/kernels/assembly
         src/core/NEON/kernels/arm_gemm/merges)

# ---------------------------------------------------------------------
# Core Library

add_library(arm_compute "")
target_compile_options(arm_compute PRIVATE "-march=${ARM_COMPUTE_ARCH}")
target_compile_definitions(arm_compute PRIVATE ARM_COMPUTE_ENABLE_BF16)
target_compile_definitions(arm_compute PRIVATE ENABLE_SVE)
target_compile_definitions(arm_compute PRIVATE ARM_COMPUTE_ENABLE_SVE)
target_include_directories(
  arm_compute
  PUBLIC $<INSTALL_INTERFACE:include>
         $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
         ${CMAKE_CURRENT_SOURCE_DIR}
  PRIVATE src
          src/cpu/kernels/assembly
          src/core/NEON/kernels/arm_gemm
          src/core/NEON/kernels/assembly
          src/core/NEON/kernels/convolution/common
          src/core/NEON/kernels/arm_conv/depthwise
          src/core/NEON/kernels/convolution/winograd)
target_compile_options(arm_compute PUBLIC ${COMMON_CXX_FLAGS})

add_library(ArmCompute::Core ALIAS arm_compute)
target_link_libraries(
  arm_compute PUBLIC arm_compute_sve arm_compute_sve2)

# ---------------------------------------------------------------------
# Graph Library

add_library(arm_compute_graph "")
target_compile_options(arm_compute_graph PRIVATE "-march=${ARM_COMPUTE_ARCH}")
target_compile_definitions(arm_compute_graph PRIVATE ENABLE_SVE)
target_compile_definitions(arm_compute_graph PRIVATE ARM_COMPUTE_ENABLE_SVE)
# add_subdirectory(src/graph)

target_include_directories(
  arm_compute_graph
  PUBLIC $<INSTALL_INTERFACE:include>
         $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
         ${CMAKE_CURRENT_SOURCE_DIR}
  PRIVATE src
          src/cpu/kernels/assembly
          src/core/NEON/kernels/arm_gemm
          src/core/NEON/kernels/assembly
          src/core/NEON/kernels/convolution/common
          src/core/NEON/kernels/arm_conv/depthwise
          src/core/NEON/kernels/convolution/winograd)
target_compile_options(arm_compute_graph PUBLIC ${COMMON_CXX_FLAGS})

add_library(ArmCompute::Graph ALIAS arm_compute_graph)

# ---------------------------------------------------------------------
# Library Target Sources
add_subdirectory(src)

if(ARM_COMPUTE_BUILD_TESTING)
  # ---------------------------------------------------------------------
  # Validation Framework Library
  add_library(arm_compute_validation_framework "")
  # target_compile_options(arm_compute_validation_framework PRIVATE
  # "-march=armv8.2-a")
  target_compile_options(arm_compute_validation_framework
                        PRIVATE "-march=${ARM_COMPUTE_ARCH}")

  add_subdirectory(tests)
  target_include_directories(
    arm_compute_validation_framework
    PUBLIC $<INSTALL_INTERFACE:include>
          $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
          ${CMAKE_CURRENT_SOURCE_DIR})
  target_compile_options(arm_compute_validation_framework
                        PUBLIC ${COMMON_CXX_FLAGS})
                        target_link_libraries(
                          arm_compute_validation_framework
      PUBLIC arm_compute arm_compute_graph)

  # ---------------------------------------------------------------------
  # Validation Binary

  add_executable(arm_compute_validation "")
  target_compile_options(arm_compute_validation PRIVATE "-march=${ARM_COMPUTE_ARCH}")
  if(ARM_COMPUTE_ENABLE_BF16_VALIDATION)
    target_compile_definitions(arm_compute_validation PRIVATE ARM_COMPUTE_ENABLE_BF16)
  endif()
  if(ARM_COMPUTE_ENABLE_SVE_VALIDATION)
    target_compile_definitions(arm_compute_validation PRIVATE ENABLE_SVE)
    target_compile_definitions(arm_compute_validation PRIVATE ARM_COMPUTE_ENABLE_SVE)
  endif()
  add_subdirectory(tests/validation)
  target_compile_options(arm_compute_validation PUBLIC ${COMMON_CXX_FLAGS})
  set_target_properties(
    arm_compute_validation PROPERTIES RUNTIME_OUTPUT_DIRECTORY
                                      "${CMAKE_BINARY_DIR}/validation")
  target_link_libraries(
    arm_compute_validation
    PUBLIC arm_compute arm_compute_graph arm_compute_validation_framework
           arm_compute_sve)
  target_link_directories(arm_compute_validation PUBLIC tests)

  # ---------------------------------------------------------------------
  # Benchmark Binary

  add_executable(arm_compute_benchmark)
  target_compile_options(arm_compute_benchmark PRIVATE "-march=${ARM_COMPUTE_ARCH}")

  add_subdirectory(tests/benchmark)
  target_compile_options(arm_compute_benchmark PUBLIC ${COMMON_CXX_FLAGS})
  set_target_properties(
    arm_compute_benchmark PROPERTIES RUNTIME_OUTPUT_DIRECTORY
                                     "${CMAKE_BINARY_DIR}/validation")
  target_link_libraries(
    arm_compute_benchmark PUBLIC arm_compute arm_compute_graph
                                 arm_compute_validation_framework)

endif() # ARM_COMPUTE_BUILD_TESTING
# ---------------------------------------------------------------------
# Examples Binaries

if(ARM_COMPUTE_BUILD_EXAMPLES)

  add_subdirectory(examples)

  # Graph Examples
  foreach(test_name ${EXAMPLE_GRAPH_NAMES})
    add_executable(
      ${test_name} "examples/${test_name}.cpp" utils/Utils.cpp
                   utils/GraphUtils.cpp utils/CommonGraphOptions.cpp)
    target_compile_options(${test_name} PRIVATE "-march=${ARM_COMPUTE_ARCH}")
    set_target_properties(
      ${test_name} PROPERTIES RUNTIME_OUTPUT_DIRECTORY
                              "${CMAKE_BINARY_DIR}/examples")
    target_link_libraries(${test_name} PUBLIC arm_compute

=== SConstruct ===
# -*- coding: utf-8 -*-

# Copyright (c) 2016-2023 Arm Limited.
#
# SPDX-License-Identifier: MIT
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to
# deal in the Software without restriction, including without limitation the
# rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
# sell copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

import SCons
import json
import os
import subprocess

def version_at_least(version, required):

    version_list = version.split('.')
    required_list = required.split('.')
    end = min(len(version_list), len(required_list))
    for i in range(0, end):
        if int(version_list[i]) < int(required_list[i]):
            return False
        elif int(version_list[i]) > int(required_list[i]):
            return True

    return True

def read_build_config_json(build_config):
    build_config_contents = {}
    custom_types = []
    custom_layouts = []
    if os.path.isfile(build_config):
        with open(build_config) as f:
            try:
                build_config_contents = json.load(f)
            except:
                print("Warning: Build configuration file is of invalid JSON format!")
    else:
        try:
            build_config_contents = json.loads(build_config)
        except:
            print("Warning: Build configuration string is of invalid JSON format!")
    if build_config_contents:
        custom_types = build_config_contents.get("data_types", [])
        custom_layouts = build_config_contents.get("data_layouts", [])
    return custom_types, custom_layouts

def update_data_type_layout_flags(env, data_types, data_layouts):
    # Manage data-types
    if any(i in data_types for i in ['all', 'fp16']):
        env.Append(CXXFLAGS = ['-DENABLE_FP16_KERNELS'])
    if any(i in data_types for i in ['all', 'fp32']):
        env.Append(CXXFLAGS = ['-DENABLE_FP32_KERNELS'])
    if any(i in data_types for i in ['all', 'qasymm8']):
        env.Append(CXXFLAGS = ['-DENABLE_QASYMM8_KERNELS'])
    if any(i in data_types for i in ['all', 'qasymm8_signed']):
        env.Append(CXXFLAGS = ['-DENABLE_QASYMM8_SIGNED_KERNELS'])
    if any(i in data_types for i in ['all', 'qsymm16']):
        env.Append(CXXFLAGS = ['-DENABLE_QSYMM16_KERNELS'])
    if any(i in data_types for i in ['all', 'integer']):
        env.Append(CXXFLAGS = ['-DENABLE_INTEGER_KERNELS'])

    # Manage data-layouts
    if any(i in data_layouts for i in ['all', 'nhwc']):
        env.Append(CXXFLAGS = ['-DENABLE_NHWC_KERNELS'])
    if any(i in data_layouts for i in ['all', 'nchw']):
        env.Append(CXXFLAGS = ['-DENABLE_NCHW_KERNELS'])

    return env


vars = Variables("scons")
vars.AddVariables(
    BoolVariable("debug", "Debug", False),
    BoolVariable("asserts", "Enable asserts (this flag is forced to 1 for debug=1)", False),
    BoolVariable("logging", "Enable Logging", False),
    EnumVariable("arch", "Target Architecture. The x86_32 and x86_64 targets can only be used with neon=0 and opencl=1.", "armv7a",
                  allowed_values=("armv7a", "armv7a-hf", "arm64-v8a", "arm64-v8.2-a", "arm64-v8.2-a-sve", "arm64-v8.2-a-sve2", "x86_32", "x86_64",
                                  "armv8a", "armv8.2-a", "armv8.2-a-sve", "armv8.6-a", "armv8.6-a-sve", "armv8.6-a-sve2", "armv8.6-a-sve2-sme2", "armv8r64", "x86")),
    EnumVariable("estate", "Execution State", "auto", allowed_values=("auto", "32", "64")),
    EnumVariable("os", "Target OS. With bare metal selected, only Arm® Neon™ (not OpenCL) can be used, static libraries get built and Neon™'s multi-threading support is disabled.", "linux", allowed_values=("linux", "android", "tizen", "macos", "bare_metal", "openbsd","windows")),
    EnumVariable("build", "Either build directly on your device (native) or cross compile from your desktop machine (cross-compile). In both cases make sure the compiler is available in your path.", "cross_compile", allowed_values=("native", "cross_compile", "embed_only")),
    BoolVariable("examples", "Build example programs", True),
    BoolVariable("gemm_tuner", "Build gemm_tuner programs", True),
    BoolVariable("Werror", "Enable/disable the -Werror compilation flag", True),
    BoolVariable("multi_isa", "Build Multi ISA binary version of library. Works for armv8a without the support for FP16 vector arithmetic. Use armv8.2-a or beyond to enable FP16 vector arithmetic support", False),
    BoolVariable("standalone", "Builds the tests as standalone executables, links statically with libgcc, libstdc++ and libarm_compute", False),
    BoolVariable("opencl", "Enable OpenCL support", True),
    BoolVariable("neon", "Enable Arm® Neon™ support", False),
    BoolVariable("embed_kernels", "Enable if you want the OpenCL kernels to be built in the library's binaries instead of being read from separate '.cl' / '.cs' files. If embed_kernels is set to 0 then the application can set the path to the folder containing the OpenCL kernel files by calling CLKernelLibrary::init(). By default the path is set to './cl_kernels'.", True),
    BoolVariable("compress_kernels", "Compress embedded OpenCL kernels in library binary using zlib. Useful for reducing the binary size. embed_kernels should be enabled", False),
    BoolVariable("set_soname", "If enabled the library will contain a SONAME and SHLIBVERSION and some symlinks will automatically be created between the objects. (requires SCons 2.4 or above)", False),
    BoolVariable("openmp", "Enable OpenMP backend. Only works when building with g++ and not clang++", False),
    BoolVariable("cppthreads", "Enable C++11 threads backend", True),
    PathVariable("build_dir", "Specify sub-folder for the build", ".", PathVariable.PathAccept),
    PathVariable("install_dir", "Specify sub-folder for the install", "", PathVariable.PathAccept),
    BoolVariable("exceptions", "Enable/disable C++ exception support", True),
    BoolVariable("high_priority", "Generate a library containing only the high priority operators", False),
    PathVariable("linker_script", "Use an external linker script", "", PathVariable.PathAccept),
    PathVariable("external_tests_dir", """Add examples, benchmarks and tests to the tests suite from an external path. In order to use this option, the external tests directory must have the following structure: 
    EXTERNAL_TESTS_DIR:
    └── tests
        ├── benchmark
        │   ├── CL
        │   ├── datasets
        │   ├── fixtures
        │   └── Neon
        └── validation
            ├── CL
            ├── datasets
            ├── fixtures
            └── Neon\n""", "", PathVariable.PathAccept),
    BoolVariable("experimental_dynamic_fusion", "Build the experimental dynamic fusion files. This option also enables opencl=1 on which it has a direct dependency.", False),
    BoolVariable("fixed_format_kernels", "Enable fixed format kernels for GEMM", False),
    BoolVariable("mapfile", "Generate a map file", False),
    ListVariable("custom_options", "Custom options that can be used to turn on/off features", "none", ["disable_mmla_fp"]),
    ListVariable("data_type_support", "Enable a list of data types to support", "all", ["qasymm8", "qasymm8_signed", "qsymm16", "fp16", "fp32", "integer"]),
    ListVariable("data_layout_support", "Enable a list of data layout to support", "all", ["nhwc", "nchw"]),
    ("toolchain_prefix", "Override the toolchain prefix; used by all toolchain components: compilers, linker, assembler etc. If unspecified, use default(auto) prefixes; if passed an empty string '' prefixes would be disabled", "auto"),
    ("compiler_prefix", "Override the compiler prefix; used by just compilers (CC,CXX); further overrides toolchain_prefix for compilers; this is for when the compiler prefixes are different from that of the linkers, archivers etc. If unspecified, this is the same as toolchain_prefix; if passed an empty string '' prefixes would be disabled", "auto"),
    BoolVariable("thread_sanitizer", "Enable ThreadSanitizer", False),
    ("extra_cxx_flags", "Extra CXX flags to be appended to the build command", ""),
    ("extra_link_flags", "Extra LD flags to be appended to the build command", ""),
    ("compiler_cache", "Command to prefix to the C and C++ compiler (e.g ccache)", ""),
    ("specs_file", "Specs file to use (e.g. rdimon.specs)", ""),
    ("build_config", "Operator/Data-type/Data-layout configuration to use for tailored ComputeLibrary builds. Can be a JSON file or a JSON formatted string", "")
)

if version_at_least(SCons.__version__, "4.0"):
    vars.Add(BoolVariable("export_compile_commands", "Export compile_commands.json file.", False))


env = Environment(variables=vars, ENV = os.environ)


build_path = env['build_dir']
# If build_dir is a relative path then add a #build/ prefix:
if not env['build_dir'].startswith('/'):
    SConsignFile('build/%s/.scons' % build_path)
    build_path = "#build/%s" % build_path
else:
    SConsignFile('%s/.scons' % build_path)

install_path = env['install_dir']
#If the install_dir is a relative path then assume it's from inside build_dir
if not env['install_dir'].startswith('/') and install_path != "":
    install_path = "%s/%s" % (build_path, install_path)

env.Append(LIBPATH = [build_path, os.path.join(build_path, "prototype")])
Export('env')
Export('vars')

def install_lib( lib ):
    # If there is no install folder, then there is nothing to do:
    if install_path == "":
        return lib
    return env.Install( "%s/lib/" % install_path, lib)
def install_bin( bin ):
    # If there is no install folder, then there is nothing to do:
    if install_path == "":
        return bin
    return env.Install( "%s/bin/" % install_path, bin)
def install_include( inc ):
    if install_path == "":
        return inc
    return env.Install( "%s/include/" % install_path, inc)

Export('install_lib')
Export('install_bin')

Help(vars.GenerateHelpText(env))

# Export compile_commands.json file
if env.get("export_compile_commands", False):
    env.Tool("compilation_db")
    env.CompilationDatabase("%s/compile_commands.json" % build_path)

if 'armv7a' in env['arch'] and env['os'] == 'android':
    print("WARNING: armv7a on Android is no longer maintained")

if env['linker_script'] and env['os'] != 'bare_metal':
    print("Linker script is only supported for bare_metal builds")
    Exit(1)

if env['build'] == "embed_only":
    SConscript('./SConscript', variant_dir=build_path, duplicate=0)
    Return()

if env['neon'] and 'x86' in env['arch']:
    print("Cannot compile Arm® Neon™ for x86")
    Exit(1)

if env['set_soname'] and not version_at_least(SCons.__version__, "2.4"):
    print("Setting the library's SONAME / SHLIBVERSION requires SCons 2.4 or above")
    print("Update your version of SCons or use set_soname=0")
    Exit(1)

if env['os'] == 'bare_metal':
    if env['cppthreads'] or env['openmp']:
         print("ERROR: OpenMP and C++11 threads not supported in bare_metal. Use cppthreads=0 openmp=0")
         Exit(1)

if env['experimental_dynamic_fusion']:
    # Dynamic Fusion on GPU has a direct dependency on OpenCL and Compute Kernel Writer
    env['opencl'] = 1

if env['opencl'] and env['embed_kernels'] and env['compress_kernels'] and env['os'] not in ['android']:

=== compute_kernel_writer/CMakeLists.txt ===
# Copyright (c) 2023 Arm Limited.
#
# SPDX-License-Identifier: MIT
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to
# deal in the Software without restriction, including without limitation the
# rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
# sell copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

cmake_minimum_required(VERSION 3.14 FATAL_ERROR)

#---------------------------------------------------------------------
# Compute Kernel Writer Project

project(ComputeKernelWriter
    VERSION 1.0.0
    LANGUAGES CXX
)

set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

include(GNUInstallDirs)

message(STATUS "${CMAKE_PROJECT_NAME} ${CMAKE_PROJECT_VERSION}")

#---------------------------------------------------------------------
# Options

option(CKW_ENABLE_OPENCL "Enable OpenCL code generation" OFF)
option(CKW_ENABLE_ASSERTS "Enable assertions. Always enabled in Debug builds" OFF)
option(CKW_BUILD_TESTING "Build the Compute Kernel Writer validation test suite" OFF)
option(CKW_BUILD_PROTOTYPE "Build the prototype implementation of kernel writer." OFF)
option(CKW_CCACHE "Use compiler cache for faster recompilation" OFF)

#---------------------------------------------------------------------
# Build configuration

get_property(CKW_IS_MULTI_CONFIG GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)

# Allow only Release or Debug builds
if(NOT CKW_IS_MULTI_CONFIG) # Single-config generators
    if(NOT CMAKE_BUILD_TYPE)
        set(CMAKE_BUILD_TYPE Release CACHE STRING "Options: Release (default) or Debug" FORCE)
    endif()
else() # Multi-config generators
    list(REMOVE_ITEM CMAKE_CONFIGURATION_TYPES RelWithDebInfo MinSizeRel)
endif()

# Simplistic CCache setup
if(CKW_CCACHE)
    find_program(CCACHE_FOUND ccache)
    if(CCACHE_FOUND)
        set(CMAKE_C_COMPILER_LAUNCHER ${CACHE_FOUND})
        set(CMAKE_CXX_COMPILER_LAUNCHER ${CACHE_FOUND})
    endif()
endif()

#---------------------------------------------------------------------
# Library targets

set(CKW_CXX_FLAGS
    -Wall
    -Werror
    -Wextra
    -Wdisabled-optimization
    -Wformat=2
    -Winit-self
    -Wstrict-overflow=2
    -Wswitch-default
    -Woverloaded-virtual
    -Wformat-security
    -Wctor-dtor-privacy
    -Wsign-promo
    -Weffc++
    -pedantic
)
set(GNU_WARNINGS
    -Wlogical-op
    -Wstrict-null-sentinel
)
set(CKW_ASSERTS_OPTS
    -fstack-protector-strong
)

add_library(ckw)
target_compile_options(ckw
    PUBLIC
    ${CKW_CXX_FLAGS}
    "$<$<CXX_COMPILER_ID:GNU>:${GNU_WARNINGS}>"
    "$<$<CONFIG:Debug>:${CKW_ASSERTS_OPTS}>"
    "$<$<BOOL:${CKW_ENABLE_ASSERTS}>:${CKW_ASSERTS_OPTS}>"
    # Set CMAKE_CXX_FLAGS last so user can overwrite options
    ${CMAKE_CXX_FLAGS}
    PRIVATE
    # Always optimize for binary size
    $<$<CONFIG:Release>:-Os>
)

target_compile_definitions(ckw PUBLIC
    $<$<CONFIG:Debug>:COMPUTE_KERNEL_WRITER_DEBUG_ENABLED>
    $<$<CONFIG:Debug>:COMPUTE_KERNEL_WRITER_ASSERTS_ENABLED>
    $<$<BOOL:${CKW_ENABLE_ASSERTS}>:COMPUTE_KERNEL_WRITER_ASSERTS_ENABLED>
    $<$<BOOL:${CKW_ENABLE_OPENCL}>:COMPUTE_KERNEL_WRITER_OPENCL_ENABLED>
)

target_sources(ckw PRIVATE
    src/Error.cpp
    src/Helpers.cpp
    src/Kernel.cpp
    src/KernelWriter.cpp
    src/TensorInfo.cpp
    src/TensorOperand.cpp
    src/TensorSampler.cpp
    src/TensorUtils.cpp
    src/TileInfo.cpp
    src/TileOperand.cpp
)

if(CKW_ENABLE_OPENCL)
    target_sources(ckw PRIVATE
        src/cl/CLTensorArgument.cpp
        src/cl/CLTensorComponent.cpp
        src/cl/CLHelpers.cpp
        src/cl/CLTile.cpp
        src/cl/CLKernelWriter.cpp
    )
endif()

target_include_directories(ckw
    PUBLIC ${CMAKE_CURRENT_LIST_DIR}/include
    PRIVATE ${CMAKE_CURRENT_LIST_DIR}
)

#---------------------------------------------------------------------
# Validation tests

if(CKW_BUILD_TESTING)
    add_executable(ckw_validation
        validation/Validation.cpp
    )

    target_link_libraries(ckw_validation PRIVATE ckw)
    target_include_directories(ckw_validation
        PRIVATE ${CMAKE_CURRENT_LIST_DIR}
    )
endif()

#---------------------------------------------------------------------
# Prototype

if(CKW_BUILD_PROTOTYPE)
    add_subdirectory(prototype)
endif()

#---------------------------------------------------------------------
# Installing

install(TARGETS ckw
    CONFIGURATIONS Release
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

install(DIRECTORY include/ckw
    DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
)

=== examples/CMakeLists.txt ===
# Copyright (c) 2023 Arm Limited.
#
# SPDX-License-Identifier: MIT
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to
# deal in the Software without restriction, including without limitation the
# rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
# sell copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

set(EXAMPLE_GRAPH_NAMES
    graph_alexnet
    graph_deepspeech_v0_4_1
    graph_edsr
    graph_googlenet
    graph_inception_resnet_v1
    graph_inception_resnet_v2
    graph_inception_v3
    graph_inception_v4
    graph_lenet
    graph_mobilenet_v2
    graph_mobilenet
    graph_resnet_v2_50
    graph_resnet12
    graph_resnet50
    graph_resnext50
    graph_shufflenet
    graph_squeezenet_v1_1
    graph_squeezenet
    graph_srcnn955
    graph_ssd_mobilenet
    graph_vgg_vdsr
    graph_vgg16
    graph_vgg19
    graph_yolov3
    PARENT_SCOPE)

set(EXAMPLE_NEON_NAMES
    neon_cnn neon_copy_objects neon_gemm_qasymm8 neon_permute neon_scale
    neon_sgemm
    PARENT_SCOPE)

=== src/CMakeLists.txt ===
# Copyright (c) 2023 Arm Limited.
#
# SPDX-License-Identifier: MIT
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to
# deal in the Software without restriction, including without limitation the
# rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
# sell copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

target_sources(
    arm_compute_graph
    PRIVATE
    graph/DataLayerVisitor.cpp
	graph/Graph.cpp
	graph/GraphBuilder.cpp
	graph/GraphContext.cpp
	graph/GraphManager.cpp
	graph/INode.cpp
	graph/INodeVisitor.cpp
	graph/PassManager.cpp
	graph/Tensor.cpp
	graph/TypeLoader.cpp
	graph/Utils.cpp
	graph/Workload.cpp
	graph/algorithms/TopologicalSort.cpp
	graph/backends/BackendRegistry.cpp
	graph/backends/NEON/NEDeviceBackend.cpp
	graph/backends/NEON/NEFunctionFactory.cpp
	graph/backends/NEON/NENodeValidator.cpp
	graph/backends/NEON/NESubTensorHandle.cpp
	graph/backends/NEON/NETensorHandle.cpp
	graph/detail/CrossLayerMemoryManagerHelpers.cpp
	graph/detail/ExecutionHelpers.cpp
	graph/frontend/Stream.cpp
	graph/frontend/SubStream.cpp
	graph/mutators/DepthConcatSubTensorMutator.cpp
	graph/mutators/GroupedConvolutionMutator.cpp
	graph/mutators/InPlaceOperationMutator.cpp
	graph/mutators/MutatorUtils.cpp
	graph/mutators/NodeExecutionMethodMutator.cpp
	graph/mutators/NodeFusionMutator.cpp
	graph/mutators/SplitLayerSubTensorMutator.cpp
	graph/mutators/SyntheticDataTypeMutator.cpp
	graph/nodes/ActivationLayerNode.cpp
	graph/nodes/ArgMinMaxLayerNode.cpp
	graph/nodes/BatchNormalizationLayerNode.cpp
	graph/nodes/BoundingBoxTransformLayerNode.cpp
	graph/nodes/ChannelShuffleLayerNode.cpp
	graph/nodes/ConcatenateLayerNode.cpp
	graph/nodes/ConstNode.cpp
	graph/nodes/ConvolutionLayerNode.cpp
	graph/nodes/DeconvolutionLayerNode.cpp
	graph/nodes/DepthToSpaceLayerNode.cpp
	graph/nodes/DepthwiseConvolutionLayerNode.cpp
	graph/nodes/DequantizationLayerNode.cpp
	graph/nodes/DetectionOutputLayerNode.cpp
	graph/nodes/DetectionPostProcessLayerNode.cpp
	graph/nodes/DummyNode.cpp
	graph/nodes/EltwiseLayerNode.cpp
	graph/nodes/FlattenLayerNode.cpp
	graph/nodes/FullyConnectedLayer.cpp
	graph/nodes/FusedConvolutionBatchNormalizationNode.cpp
	graph/nodes/FusedConvolutionBatchNormalizationWithPostOpsNode.cpp
	graph/nodes/FusedConvolutionWithPostOpNode.cpp
	graph/nodes/FusedDepthwiseConvolutionBatchNormalizationNode.cpp
	graph/nodes/GenerateProposalsLayerNode.cpp
	graph/nodes/InputNode.cpp
	graph/nodes/L2NormalizeLayerNode.cpp
	graph/nodes/NormalizationLayerNode.cpp
	graph/nodes/NormalizePlanarYUVLayerNode.cpp
	graph/nodes/OutputNode.cpp
	graph/nodes/PReluLayerNode.cpp
	graph/nodes/PadLayerNode.cpp
	graph/nodes/PermuteLayerNode.cpp
	graph/nodes/PoolingLayerNode.cpp
	graph/nodes/PrintLayerNode.cpp
	graph/nodes/PriorBoxLayerNode.cpp
	graph/nodes/QuantizationLayerNode.cpp
	graph/nodes/ROIAlignLayerNode.cpp
	graph/nodes/ReductionLayerNode.cpp
	graph/nodes/ReorgLayerNode.cpp
	graph/nodes/ReshapeLayer.cpp
	graph/nodes/ResizeLayerNode.cpp
	graph/nodes/SliceLayerNode.cpp
	graph/nodes/SoftmaxLayerNode.cpp
	graph/nodes/SplitLayerNode.cpp
	graph/nodes/StackLayerNode.cpp
	graph/nodes/StridedSliceLayerNode.cpp
	graph/printers/DotGraphPrinter.cpp
)

target_sources(
    arm_compute_sve
    PRIVATE
    core/NEON/kernels/arm_conv/depthwise/interleaves/sve_s8q_3x3_dot.cpp
	core/NEON/kernels/arm_conv/depthwise/interleaves/sve_u8q_3x3_dot.cpp
	core/NEON/kernels/arm_conv/depthwise/kernels/sme2_fp16_nhwc_3x3_s1_output2x2_mla_depthfirst/generic_direct.cpp
	core/NEON/kernels/arm_conv/depthwise/kernels/sme2_fp16_nhwc_3x3_s1_output2x2_mla_depthfirst/generic_indirect.cpp
	core/NEON/kernels/arm_conv/depthwise/kernels/sme2_fp16_nhwc_3x3_s1_output3x3_mla_depthfirst/generic_direct.cpp
	core/NEON/kernels/arm_conv/depthwise/kernels/sme2_fp16_nhwc_3x3_s1_output3x3_mla_depthfirst/generic_indirect.cpp
	core/NEON/kernels/arm_conv/depthwise/kernels/sme2_fp16_nhwc_3x3_s1_output4x4_mla_depthfirst/generic_direct.cpp
	core/NEON/kernels/arm_conv/depthwise/kernels/sme2_fp16_nhwc_3x3_s1_output4x4_mla_depthfirst/generic_indirect.cpp
	core/NEON/kernels/arm_conv/depthwise/kernels/sme2_fp16_nhwc_3x3_s2_output2x2_mla_depthfirst/generic_direct.cpp
	core/NEON/kernels/arm_conv/depthwise/kernels/sme2_fp16_nhwc_3x3_s2_output2x2_mla_depthfirst/generic_indirect.cpp
	core/NEON/kernels/arm_conv/depthwise/kernels/sme2_fp16_nhwc_5x5_s1_output2x2_mla_depthfirst/generic_direct.cpp
	core/NEON/kernels/arm_conv/depthwise/kernels/sme2_fp16_nhwc_5x5_s1_output2x2_mla_depthfirst/generic_indirect.cpp
	core/NEON/kernels/arm_conv/depthwise/kernels/sme2_fp32_nhwc_3x3_s1_output2x2_mla_depthfirst/generic_direct.cpp
	core/NEON/kernels/arm_conv/depthwise/kernels/sme2_fp32_nhwc_3x3_s1_output2x2_mla_depthfirst/generic_indirect.cpp
	core/NEON/kernels/arm_conv/depthwise/kernels/sme2_fp32_nhwc_3x3_s1_output3x3_mla_depthfirst/generic_direct.cpp
	core/NEON/kernels/arm_conv/depthwise/kernels/sme2_fp32_nhwc_3x3_s1_output3x3_mla_depthfirst/generic_indirect.cpp
	core/NEON/kernels/arm_conv/depthwise/kernels/sme2_fp32_nhwc_3x3_s1_output4x4_mla_depthfirst/generic_direct.cpp
	core/NEON/kernels/arm_conv/depthwise/kernels/sme2_fp32_nhwc_3x3_s1_output4x4_mla_depthfirst/generic_indirect.cpp
	core/NEON/kernels/arm_conv/depthwise/kernels/sme2_fp32_nhwc_3x3_s2_output2x2_mla_depthfirst/generic_direct.cpp
	core/NEON/kernels/arm_conv/depthwise/kernels/sme2_fp32_nhwc_3x3_s2_output2x2_mla_depthfirst/generic_indirect.cpp
	core/NEON/kernels/arm_conv/depthwise/kernels/sme2_fp32_planar_3x3_s1_4rows_mla_za/generic.cpp
	core/NEON/kernels/arm_conv/depthwise/kernels/sme2_fp32_planar_3x3_s2_4rows_mla_za/generic.cpp
	core/NEON/kernels/arm_conv/depthwise/kernels/sme2_fp32_planar_5x5_s1_4rows_mla_za/generic.cpp
	core/NEON/kernels/arm_conv/depthwise/kernels/sme2_fp32_planar_5x5_s2_4rows_mla_za/generic.cpp
	core/NEON/kernels/arm_conv/depthwise/kernels/sme2_fp32bf16fp32_planar_3x3_s1_4rows_dot_za/generic.cpp
	core/NEON/kernels/arm_conv/depthwise/kernels/sme2_fp32bf16fp32_planar_3x3_s2_4rows_dot_za/generic.cpp
	core/NEON/kernels/arm_conv/depthwise/kernels/sme2_fp32bf16fp32_planar_5x5_s1_4rows_dot_za/generic.cpp
	core/NEON/kernels/arm_conv/depthwise/kernels/sme2_fp32bf16fp32_planar_5x5_s2_4rows_dot_za/generic.cpp
	core/NEON/kernels/arm_conv/depthwise/kernels/sme2_s8q_planar_3x3_s1_4rows_dot_za/generic.cpp
	core/NEON/kernels/arm_conv/depthwise/kernels/sme2_s8q_planar_3x3_s2_4rows_dot_za/generic.cpp
	core/NEON/kernels/arm_conv/depthwise/kernels/sme2_s8q_planar_5x5_s1_4rows_dot_za/generic.cpp
	core/NEON/kernels/arm_conv/depthwise/kernels/sme2_s8q_planar_5x5_s2_4rows_dot_za/generic.cpp
	core/NEON/kernels/arm_conv/depthwise/kernels/sme2_u8q_planar_3x3_s1_4rows_dot_za/generic.cpp
	core/NEON/kernels/arm_conv/depthwise/kernels/sme2_u8q_planar_3x3_s2_4rows_dot_za/generic.cpp
	core/NEON/kernels/arm_conv/depthwise/kernels/sme2_u8q_planar_5x5_s1_4rows_dot_za/generic.cpp
	core/NEON/kernels/arm_conv/depthwise/kernels/sme2_u8q_planar_5x5_s2_4rows_dot_za/generic.cpp
	core/NEON/kernels/arm_conv/depthwise/kernels/sme2_u8s8u8q_planar_3x3_s1_4rows_dot_za/generic.cpp
	core/NEON/kernels/arm_conv/depthwise/kernels/sme2_u8s8u8q_planar_3x3_s2_4rows_dot_za/generic.cpp
	core/NEON/kernels/arm_conv/depthwise/kernels/sme2_u8s8u8q_planar_5x5_s1_4rows_dot_za/generic.cpp
	core/NEON/kernels/arm_conv/depthwise/kernels/sme2_u8s8u8q_planar_5x5_s2_4rows_dot_za/generic.cpp
	core/NEON/kernels/arm_conv/depthwise/kernels/sve_fp16_nhwc_3x3_s1_output2x2_mla_depthfirst/generic_direct.cpp
	core/NEON/kernels/arm_conv/depthwise/kernels/sve_fp16_nhwc_3x3_s1_output2x2_mla_depthfirst/generic_indirect.cpp
	core/NEON/kernels/arm_conv/depthwise/kernels/sve_fp16_nhwc_3x3_s1_output3x3_mla_depthfirst/generic_direct.cpp
	core/NEON/kernels/arm_conv/depthwise/kernels/sve_fp16_nhwc_3x3_s1_output3x3_mla_depthfirst/generic_indirect.cpp
	core/NEON/kernels/arm_conv/depthwise/kernels/sve_fp16_nhwc_3x3_s1_output4x4_mla_depthfirst/generic_direct.cpp
	core/NEON/kernels/arm_conv/depthwise/kernels/sve_fp16_nhwc_3x3_s1_output4x4_mla_depthfirst/generic_indirect.cpp
	core/NEON/kernels/arm_conv/depthwise/kernels/sve_fp16_nhwc_3x3_s2_output2x2_mla_depthfirst/generic_direct.cpp
	core/NEON/kernels/arm_conv/depthwise/kernels/sve_fp16_nhwc_3x3_s2_output2x2_mla_depthfirst/generic_indirect.cpp
	core/NEON/kernels/arm_conv/depthwise/kernels/sve_fp16_nhwc_5x5_s1_output2x2_mla_depthfirst/generic_direct.cpp
	core/NEON/kernels/arm_conv/depthwise/kernels/sve_fp16_nhwc_5x5_s1_output2x2_mla_depthfirst/generic_indirect.cpp
	core/NEON/kernels/arm_conv/depthwise/kernels/sve_fp32_nhwc_3x3_s1_output2x2_mla_depthfirst/generic_direct.cpp
	core/NEON/kernels/arm_conv/depthwise/kernels/sve_fp32_nhwc_3x3_s1_output2x2_mla_depthfirst/generic_indirect.cpp
	core/NEON/kernels/arm_conv/depthwise/kernels/sve_fp32_nhwc_3x3_s1_output3x3_mla_depthfirst/generic_direct.cpp
	core/NEON/kernels/arm_conv/depthwise/kernels/sve_fp32_nhwc_3x3_s1_output3x3_mla_depthfirst/generic_indirect.cpp
	core/NEON/kernels/arm_conv/depthwise/kernels/sve_fp32_nhwc_3x3_s1_output4x4_mla_depthfirst/generic_direct.cpp
	core/NEON/kernels/arm_conv/depthwise/kernels/sve_fp32_nhwc_3x3_s1_output4x4_mla_depthfirst/generic_indirect.cpp
	core/NEON/kernels/arm_conv/depthwise/kernels/sve_fp32_nhwc_3x3_s2_output2x2_mla_depthfirst/generic_direct.cpp
	core/NEON/kernels/arm_conv/depthwise/kernels/sve_fp32_nhwc_3x3_s2_output2x2_mla_depthfirst/generic_indirect.cpp
	core/NEON/kernels/arm_conv/depthwise/kernels/sve_fp32_nhwc_5x5_s1_output2x2_mla_depthfirst/generic_direct.cpp
	core/NEON/kernels/arm_conv/depthwise/kernels/sve_fp32_nhwc_5x5_s1_output2x2_mla_depthfirst/generic_indirect.cpp
	core/NEON/kernels/arm_conv/depthwise/kernels/sve_fp32_nhwc_generic_output9_mla_depthfirst/generic.cpp
	core/NEON/kernels/arm_conv/depthwise/kernels/sve_fp32_packed_to_nhwc_3x3_s2_with_multiplier_output3x3_mla_depthfirst/generic.cpp
	core/NEON/kernels/arm_conv/depthwise/kernels/sve_fp32_packed_to_nhwc_5x5_s1_with_multiplier_output2x4_mla_depthfirst/generic.cpp
	core/NEON/kernels/arm_conv/depthwise/kernels/sve_fp32_packed_to_nhwc_generic_with_multiplier_output2x8_mla_depthfirst/generic.cpp
	core/NEON/kernels/arm_conv/depthwise/kernels/sve_s8q_nhwc_3x3_s1_output2x2_dot_depthfirst/generic.cpp
	core/NEON/kernels/arm_conv/depthwise/kernels/sve_s8q_nhwc_3x3_s1_output2x2_mla_depthfirst/generic.cpp
	core/NEON/kernels/arm_conv/depthwise/kernels/sve_s8q_nhwc_3x3_s2_output2x2_mla_depthfirst/generic.cpp
	core/NEON/kernels/arm_conv/depthwise/kernels/sve_s8q_nhwc_5x5_s1_output2x2_mla_depthfirst/generic.cpp
	core/NEON/kernels/arm_conv/depthwise/kernels/sve_s8q_packed_to_nhwc_3x3_s2_with_multiplier_output2x4_dot_depthfirst/generic.cpp
	core/NEON/kernels/arm_conv/depthwise/kernels/sve_s8q_packed_to_nhwc_5x5_s1_with_multiplier_output4x2_dot_depthfirst/generic.cpp
	core/NEON/kernels/arm_conv/depthwise/kernels/sve_s8qs_nhwc_3x3_s1_output2x2_dot_depthfirst/generic.cpp
	core/NEON/kernels/arm_conv/depthwise/kernels/sve_u8q_nhwc_3x3_s1_output2x2_dot_depthfirst/generic.cpp
	core/NEON/kernels/arm_conv/depthwise/kernels/sve_u8q_nhwc_3x3_s1_output2x2_mla_depthfirst/generic.cpp
	core/NEON/kernels/arm_conv/depthwise/kernels/sve_u8q_nhwc_3x3_s2_output2x2_mla_depthfirst/generic.cpp

=== tests/CMakeLists.txt ===
# Copyright (c) 2023 Arm Limited.
#
# SPDX-License-Identifier: MIT
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to
# deal in the Software without restriction, including without limitation the
# rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
# sell copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

target_sources(
  arm_compute_validation_framework
  PRIVATE validation/Validation.cpp
          validation/Helpers.cpp
          validation/reference/BoundingBoxTransform.cpp
          validation/reference/GEMMReshapeRHSMatrix.cpp
          validation/reference/ChannelShuffle.cpp
          validation/reference/Logical.cpp
          validation/reference/PoolingLayer.cpp
          validation/reference/BitwiseNot.cpp
          validation/reference/Conv3D.cpp
          validation/reference/GEMMReshapeLHSMatrix.cpp
          validation/reference/ComputeAllAnchors.cpp
          validation/reference/DepthConcatenateLayer.cpp
          validation/reference/TableLookup.cpp
          validation/reference/ROIPoolingLayer.cpp
          validation/reference/SliceOperations.cpp
          validation/reference/GEMMLowp.cpp
          validation/reference/Unstack.cpp
          validation/reference/Pooling3dLayer.cpp
          validation/reference/BitwiseOr.cpp
          validation/reference/ReshapeLayer.cpp
          validation/reference/SoftmaxLayer.cpp
          validation/reference/Gather.cpp
          validation/reference/Utils.cpp
          validation/reference/Accumulate.cpp
          validation/reference/CropResize.cpp
          validation/reference/ReductionOperation.cpp
          validation/reference/ConcatenateLayer.cpp
          validation/reference/PixelWiseMultiplication.cpp
          validation/reference/DepthConvertLayer.cpp
          validation/reference/Erode.cpp
          validation/reference/DepthToSpaceLayer.cpp
          validation/reference/PadLayer.cpp
          validation/reference/MeanStdDevNormalizationLayer.cpp
          validation/reference/BitwiseXor.cpp
          validation/reference/GEMM.cpp
          validation/reference/NormalizePlanarYUVLayer.cpp
          validation/reference/FuseBatchNormalization.cpp
          validation/reference/BitwiseAnd.cpp
          validation/reference/SpaceToDepth.cpp
          validation/reference/NonMaximaSuppression.cpp
          validation/reference/Reverse.cpp
          validation/reference/DFT.cpp
          validation/reference/L2NormalizeLayer.cpp
          validation/reference/ActivationLayer.cpp
          validation/reference/SpaceToBatch.cpp
          validation/reference/PostOps.cpp
          validation/reference/Im2Col.cpp
          validation/reference/DequantizationLayer.cpp
          validation/reference/DeconvolutionLayer.cpp
          validation/reference/MinMaxLocation.cpp
          validation/reference/Select.cpp
          validation/reference/BatchNormalizationLayer.cpp
          validation/reference/InstanceNormalizationLayer.cpp
          validation/reference/ROIAlignLayer.cpp
          validation/reference/ElementwiseUnary.cpp
          validation/reference/MeanStdDev.cpp
          validation/reference/QLSTMLayerNormalization.cpp
          validation/reference/Col2Im.cpp
          validation/reference/FlattenLayer.cpp
          validation/reference/AbsoluteDifference.cpp
          validation/reference/Transpose.cpp
          validation/reference/StackLayer.cpp
          validation/reference/NormalizationLayer.cpp
          validation/reference/Copy.cpp
          validation/reference/MaxUnpoolingLayer.cpp
          validation/reference/Winograd.cpp
          validation/reference/Permute.cpp
          validation/reference/Comparisons.cpp
          validation/reference/Tile.cpp
          validation/reference/BatchToSpaceLayer.cpp
          validation/reference/ElementwiseOperations.cpp
          validation/reference/QuantizationLayer.cpp
          validation/reference/NonMaxSuppression.cpp
          validation/reference/WeightsReshape.cpp
          validation/reference/ArithmeticOperations.cpp
          validation/reference/ConvertFullyConnectedWeights.cpp
          validation/reference/Floor.cpp
          validation/reference/PriorBoxLayer.cpp
          validation/reference/Scale.cpp
          validation/reference/ReorgLayer.cpp
          validation/reference/Range.cpp
          validation/reference/ArithmeticDivision.cpp
          validation/reference/DepthwiseConvolutionLayer.cpp
          validation/reference/FullyConnectedLayer.cpp
          validation/reference/ConvolutionLayer.cpp
          validation/reference/Reorder.cpp
          framework/Framework.cpp
          framework/Utils.cpp
          framework/Exceptions.cpp
          framework/DatasetModes.cpp
          framework/TestFilter.cpp
          framework/Profiler.cpp
          framework/ParametersLibrary.cpp
          framework/command_line/CommonOptions.cpp
          framework/instruments/WallClockTimer.cpp
          framework/instruments/InstrumentsStats.cpp
          framework/instruments/Instruments.cpp
          framework/instruments/SchedulerTimer.cpp
          framework/instruments/hwc_names.hpp
          framework/instruments/hwc.hpp
          framework/printers/PrettyPrinter.cpp
          framework/printers/Printer.cpp
          framework/printers/JSONPrinter.cpp
          framework/printers/Printers.cpp
          AssetsLibrary.cpp
          RawTensor.cpp
          main.cpp)

=== compute_kernel_writer/prototype/CMakeLists.txt ===
# Copyright (c) 2023 Arm Limited.
#
# SPDX-License-Identifier: MIT
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to
# deal in the Software without restriction, including without limitation the
# rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
# sell copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

cmake_minimum_required(VERSION 3.14 FATAL_ERROR)

#---------------------------------------------------------------------
# Prototype

add_library(ckw_prototype
    src/TileInfo.cpp
    src/TensorInfo.cpp
    src/Kernel.cpp
    src/KernelWriter.cpp
    src/OperandBase.cpp
    src/TileOperand.cpp
    src/TensorOperand.cpp
    src/TensorTileSampler.cpp
    src/KernelArgument.cpp
)

target_compile_options(ckw_prototype
    PUBLIC
    ${CKW_CXX_FLAGS}
    "$<$<CXX_COMPILER_ID:GNU>:${GNU_WARNINGS}>"
    "$<$<CONFIG:Debug>:${CKW_ASSERTS_OPTS}>"
    "$<$<BOOL:${CKW_ASSERTS}>:${CKW_ASSERTS_OPTS}>"
    ${CMAKE_CXX_FLAGS}
    PRIVATE
    $<$<CONFIG:Release>:-Os>
)

target_compile_definitions(ckw_prototype PUBLIC
    $<$<CONFIG:Debug>:COMPUTE_KERNEL_WRITER_DEBUG_ENABLED>
    $<$<CONFIG:Debug>:COMPUTE_KERNEL_WRITER_ASSERTS_ENABLED>
    $<$<BOOL:${CKW_ASSERTS}>:COMPUTE_KERNEL_WRITER_ASSERTS_ENABLED>
    $<$<BOOL:${CKW_ENABLE_OPENCL}>:COMPUTE_KERNEL_WRITER_OPENCL_ENABLED>
)

target_include_directories(ckw_prototype
    PUBLIC ${CMAKE_CURRENT_LIST_DIR}/include
    PRIVATE ${CMAKE_CURRENT_LIST_DIR}
)

#---------------------------------------------------------------------
# Examples

add_library(ckw_prototype_examples_common
    examples/common/ExampleKernelWriter.cpp
    examples/common/ExampleScopedKernelWriter.cpp
    examples/common/ExampleComponentArgument.cpp
)

target_link_libraries(ckw_prototype_examples_common PUBLIC ckw_prototype)

add_executable(ckw_prototype_examples_add_exp_store examples/add_exp_store.cpp)
target_link_libraries(ckw_prototype_examples_add_exp_store PUBLIC ckw_prototype_examples_common)

add_executable(writer_helper examples/writer_helper.cpp)
target_link_libraries(writer_helper PUBLIC ckw_prototype)

=== tests/benchmark/CMakeLists.txt ===
# Copyright (c) 2023 Arm Limited.
#
# SPDX-License-Identifier: MIT
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to
# deal in the Software without restriction, including without limitation the
# rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
# sell copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

target_sources(arm_compute_benchmark PRIVATE NEON/Scale.cpp)

=== tests/validation/CMakeLists.txt ===
# Copyright (c) 2023 Arm Limited.
#
# SPDX-License-Identifier: MIT
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to
# deal in the Software without restriction, including without limitation the
# rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
# sell copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

target_sources(
  arm_compute_validation
  PRIVATE UNIT/SafeIntegerOps.cpp
          UNIT/Version.cpp
          UNIT/TensorInfo.cpp
          UNIT/TensorShape.cpp
          UNIT/Utils.cpp
          UNIT/SubTensorInfo.cpp
          UNIT/WindowIterator.cpp
          UNIT/LifetimeManager.cpp
          UNIT/GPUTarget.cpp
          CPP/DetectionPostProcessLayer.cpp
          CPP/TopKV.cpp
          CPP/DFT.cpp
          CPP/Permute.cpp
          CPP/NonMaximumSuppression.cpp)

if(ENABLE_NEON)
  target_sources(
    arm_compute_validation
    PRIVATE NEON/ElementwiseNegation.cpp
            NEON/BoundingBoxTransform.cpp
            NEON/ChannelShuffle.cpp
            NEON/Logical.cpp
            NEON/DilatedConvolutionLayer.cpp
            NEON/PoolingLayer.cpp
            NEON/BitwiseNot.cpp
            NEON/FillBorder.cpp
            NEON/ElementwiseRsqrtLayer.cpp
            NEON/DepthConcatenateLayer.cpp
            NEON/ElementwisePower.cpp
            NEON/Fill.cpp
            NEON/ROIPoolingLayer.cpp
            NEON/LSTMLayer.cpp
            NEON/ArithmeticSubtraction.cpp
            NEON/GEMMLowp.cpp
            NEON/Unstack.cpp
            NEON/Slice.cpp
            NEON/Pooling3dLayer.cpp
            NEON/BitwiseOr.cpp
            NEON/HeightConcatenateLayer.cpp
            NEON/ReshapeLayer.cpp
            NEON/SoftmaxLayer.cpp
            NEON/Gather.cpp
            NEON/CropResize.cpp
            NEON/ReductionOperation.cpp
            NEON/PixelWiseMultiplication.cpp
            NEON/LogSoftmaxLayer.cpp
            NEON/DepthConvertLayer.cpp
            NEON/Flatten.cpp
            NEON/ElementwiseKernelSelection.cpp
            NEON/DepthToSpaceLayer.cpp
            NEON/ElementwiseAbsoluteValue.cpp
            NEON/PadLayer.cpp
            NEON/MeanStdDevNormalizationLayer.cpp
            NEON/GlobalPoolingLayer.cpp
            NEON/RNNLayer.cpp
            NEON/DetectionPostProcessLayer.cpp
            NEON/ElementwiseRound.cpp
            NEON/BitwiseXor.cpp
            NEON/GEMM.cpp
            NEON/FuseBatchNormalization.cpp
            NEON/BitwiseAnd.cpp
            NEON/ElementwiseMax.cpp
            NEON/ReduceMean.cpp
            NEON/Reverse.cpp
            NEON/L2NormalizeLayer.cpp
            NEON/Convolution3D.cpp
            NEON/ArithmeticAddition.cpp
            NEON/ActivationLayer.cpp
            NEON/SpaceToBatchLayer.cpp
            NEON/ElementwiseLog.cpp
            NEON/LSTMLayerQuantized.cpp
            NEON/Im2Col.cpp
            NEON/DequantizationLayer.cpp
            NEON/DeconvolutionLayer.cpp
            NEON/Select.cpp
            NEON/ElementwiseSin.cpp
            NEON/PReluLayer.cpp
            NEON/BatchNormalizationLayer.cpp
            NEON/ElementwiseMin.cpp
            NEON/InstanceNormalizationLayer.cpp
            NEON/ROIAlignLayer.cpp
            NEON/ElementwiseDivision.cpp
            NEON/ElementwiseExpLayer.cpp
            NEON/ArgMinMax.cpp
            NEON/QLSTMLayerNormalization.cpp
            NEON/Col2Im.cpp
            NEON/Split.cpp
            NEON/Transpose.cpp
            NEON/GenerateProposalsLayer.cpp
            NEON/StackLayer.cpp
            NEON/WidthConcatenateLayer.cpp
            NEON/NormalizationLayer.cpp
            NEON/Copy.cpp
            NEON/ElementwiseSquareDiff.cpp
            NEON/MaxUnpoolingLayer.cpp
            NEON/Permute.cpp
            NEON/Comparisons.cpp
            NEON/BatchConcatenateLayer.cpp
            NEON/Tile.cpp
            NEON/BatchToSpaceLayer.cpp
            NEON/SpaceToDepthLayer.cpp
            NEON/DepthwiseConvolutionLayerNative.cpp
            NEON/QuantizationLayer.cpp
            NEON/ConvertFullyConnectedWeights.cpp
            NEON/Floor.cpp
            NEON/FFT.cpp
            NEON/Cast.cpp
            NEON/PriorBoxLayer.cpp
            NEON/Scale.cpp
            NEON/ReorgLayer.cpp
            NEON/Range.cpp
            NEON/DirectConvolutionLayer.cpp
            NEON/DepthwiseConvolutionLayer.cpp
            NEON/FullyConnectedLayer.cpp
            NEON/ConvolutionLayer.cpp
            NEON/StridedSlice.cpp
            NEON/ReorderLayer.cpp
            NEON/UNIT/DynamicTensor.cpp
            NEON/UNIT/TensorAllocator.cpp
            NEON/UNIT/MemoryManager.cpp
            NEON/UNIT/RuntimeContext.cpp)
endif()

=== debian/changelog ===
arm-compute-library (23.08+dfsg-2) unstable; urgency=medium

  * Source-only upload.
  * Set Standards-Versions to 4.6.2.

 -- Emanuele Rocca <ema@debian.org>  Mon, 28 Aug 2023 10:50:09 +0200

arm-compute-library (23.08+dfsg-1) unstable; urgency=medium

  * New upstream release (Closes: #1049869)
  * Rename binary package to libarm-compute32 for soname bump.
  * Build on amd64 as well.
  * Split assembler block in a32_merge_float_8x6.hpp to fix FTBFS on armhf.
  * Build with buildsystem=none.
  * Drop gles_compute from scons arguments.
  * Build with debug=1 to include debug symbols.
  * Drop libarm_compute_core, now an empty dummy library.
  * Set debhelper compatibility level to 13 to get dh_install variable
    expansion without dh-exec. Drop build-dependency on dh-exec.
  * Add debian/README.source.
  * debian/watch: add dversionmangle for +dfsg suffix.

 -- Emanuele Rocca <ema@debian.org>  Thu, 24 Aug 2023 20:15:14 +0200

=== debian/control ===
Source: arm-compute-library
Section: libs
Priority: optional
Maintainer: Compute Library Team <developer-compute@arm.com>
Uploaders: Georgios Pinitas <georgios.pinitas@arm.com>, Emanuele Rocca <ema@debian.org>
Standards-Version: 4.6.2
Homepage: https://github.com/ARM-software/ComputeLibrary
Vcs-git: https://salsa.debian.org/wookey/arm-compute-library
Rules-Requires-Root: no
Build-Depends: debhelper-compat (= 13),
               scons (>= 2.4),
               doxygen,
               graphviz

Package: libarm-compute32
Architecture: amd64 armhf arm64
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Arm Compute Library
 Arm Compute Library is a software library for computer vision and
 machine learning.  It is a collection of low-level functions
 optimized for Arm CPU and GPU architectures targeted at image
 processing, computer vision, and machine learning.  Arm Compute
 Library is usable as a shared or static library.
 .
 Both 32 and 64-bit variants are supported. (ARM v7, 32-bit, armhf,
 and ARM v8, 64-bit, aarch64/arm64)

Package: libarm-compute-dev
Section: libdevel
Architecture: amd64 armhf arm64
Multi-Arch: same
Depends: libarm-compute32 (= ${binary:Version}), ${misc:Depends}
Suggests: libarm-compute-doc (= ${source:Version})
Description: Arm Compute Library - development files
 Arm Compute Library is a software library for computer vision and
 machine learning.  It is a collection of low-level functions
 optimized for Arm CPU and GPU architectures targeted at image
 processing, computer vision, and machine learning.  Arm Compute
 Library is usable as a shared or static library.
 .
 Both 32 and 64-bit variants are supported: armhf (ARM v7, 32-bit),
 and arm64 (ARM v8, 64-bit, aarch64)
 .
 This package contains the development files (headers, static library)

Package: libarm-compute-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}, libjs-mathjax
Multi-Arch: foreign
Description: Arm Compute Library - documentation
 Arm Compute Library is a software library for computer vision and
 machine learning.  It is a collection of low-level functions
 optimized for Arm CPU and GPU architectures targeted at image
 processing, computer vision, and machine learning.  Arm Compute
 Library is usable as a shared or static library.
 .
 Both 32 and 64-bit variants are supported: armhf (ARM v7, 32-bit),
 and arm64 (ARM v8, 64-bit, aarch64)
 .
 This package contains the Compute Library documentation as HTML.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
DH_VERBOSE = 1

# see EXAMPLES in dpkg-buildflags(1) and read /usr/share/dpkg/*
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

%:
	dh $@ --buildsystem=none

ifeq ($(DEB_TARGET_ARCH),armhf)
ACL_ARCH_OPTS := arch=armv7a neon=1
else ifeq ($(DEB_TARGET_ARCH),arm64)
ACL_ARCH_OPTS := arch=arm64-v8a neon=1
else ifeq ($(DEB_TARGET_ARCH),amd64)
ACL_ARCH_OPTS := arch=x86_64 neon=0
endif

VERSION=$(shell dpkg-parsechangelog -S version | awk '{split($$0,a,"-"); print a[1]}')

SCONS=scons
OPTIONS := $(ACL_ARCH_OPTS) opencl=1 asserts=0 debug=1 Werror=0 os=linux build=native embed_kernels=1 set_soname=1 validation_tests=0 benchmark_tests=0
# Build log should be verbose unless 'terse' is set
ifneq (,$(filter terse,$(DEB_BUILD_OPTIONS)))
    OPTIONS += -s
endif

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    OPTIONS += -j$(NUMJOBS)
endif
# support nostrip and debug too?

override_dh_auto_build-arch:
	$(SCONS) $(OPTIONS) install_dir=install
	# Generate pkgconfig files
	for lib in arm_compute arm_compute_graph; do \
	sed -e "s/@DEB_HOST_MULTIARCH@/$(DEB_HOST_MULTIARCH)/" < debian/lib$${lib}.pc.in > debian/$${lib}.pc && \
	sed -i -e "s:@VERSION@:$(VERSION):" debian/$${lib}.pc; \
	done

override_dh_auto_build-indep:
	mkdir -p build/docs
	doxygen docs/Doxyfile && touch debian/docs.stamp

DOCDIR=debian/tmp
override_dh_auto_install-indep: debian/docs.stamp
	mkdir -p $(DOCDIR)
	cp -a --reflink=auto build/docs/html $(DOCDIR)
	cp -a debian/ACL_logo.png $(DOCDIR)

override_dh_auto_clean:
	dh_auto_clean
	rm -rf build
	rm -rf documentation
	rm -rf .sconf_tem/ .sconsign.dblite config.log
	rm -f debian/arm_*.pc
	rm -f debian/docs.stamp
